package common;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;

import common.bluray.PlayListAnalyzer;

import demux.pes.XplHelper;

public class DiskFinder {
	private static final String HDDVD_PATH="ADV_OBJ";
	private static final String BLURAY_PATH="BDMV/PLAYLIST";
	private static final String A="A:\\";
	private static final String B="B:\\";
	public static final long MAX_LENGTH=4*60*60*1000;//4 hours
	public static final long MIN_LENGTH=40*60*1000;//40 Minutes
	
	private static PlayListAnalyzer playListAnalyzer=new PlayListAnalyzer();
	
	private boolean bluRay;
	private boolean hdDvd;
	
	public DiskFinder(boolean bluRay, boolean hdDvd) {
		this.bluRay=bluRay;
		this.hdDvd=hdDvd;
	}
	
	public DiskStream[] find() throws IOException {
		File rootFileArray[]=File.listRoots();
		ArrayList<FileStream> fileStreamList=new ArrayList<FileStream>(rootFileArray.length);
		for (int i=0;i<rootFileArray.length;i++) {
			File rootDir=rootFileArray[i];
			if (!(A.equals(rootDir.getAbsolutePath()) || B.equals(rootDir.getAbsolutePath()))) {
				File hdDvdFile=new File(rootDir,HDDVD_PATH);
				File bluRayFile=new File(rootDir, BLURAY_PATH);
				DiskStream diskStream=null;
				if (hdDvd && hdDvdFile.isDirectory()) {
					diskStream=getHdDvdDiskStream(hdDvdFile);
					if (diskStream!=null) {
						fileStreamList.add(diskStream);
					}				
				} else if (bluRay && bluRayFile.isDirectory()) {
					DiskStream diskStreamArray[]=getBluRayDiskStream(bluRayFile);
					for (int a=0;a<diskStreamArray.length;a++) {
						fileStreamList.add(diskStreamArray[a]);
					}
				}

			}
		}
		DiskStream fileStreamArray[]=new DiskStream[fileStreamList.size()];
		fileStreamList.toArray(fileStreamArray);
		return fileStreamArray;
	}
	
	private static DiskStream getHdDvdDiskStream(File hdDvdFile) throws IOException {
		File xplFile=new File(hdDvdFile, "VPLST000.XPL");
		
		if (xplFile.canRead())  {
			try {
				XplHelper helper=new XplHelper(xplFile);
				return helper.findMainMovie();
			} catch (ParserConfigurationException e) {
				// TODO Auto-generated catch block
				throw new RuntimeException(e);
			} catch (SAXException e) {
				// TODO Auto-generated catch block
				throw new RuntimeException(e);
			}
		}
		return null;
	}
	
	private static DiskStream []getBluRayDiskStream(File bluRayFile) throws IOException {
		return playListAnalyzer.getTitles(bluRayFile,true);
		
	}
	
	public static void main(String args[]) {
		try {
			DiskFinder diskFinder=new DiskFinder(true, true);
			DiskStream array[]=diskFinder.find();
			for (int i=0;i<array.length;i++) {
				System.out.println(array[i]);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
}
